## PLAIN TEXT ##


if ($path) {
	unless (-e "$path/members") {
		mkdir("$path/members", 0777);
		chmod(0777,"$path/members");
	}	
	
	unless (-e "$path/members/accounts") {
		mkdir("$path/members/accounts", 0777);
		chmod(0777,"$path/members/accounts");

		my @char_set = ('a'..'z','0'..'9');

		foreach $ch(@char_set) {
			mkdir("$path/members/accounts/$ch", 0777);
			chmod(0777,"$path/members/accounts/$ch");
		}
	}
}

package Account;
$dbtype="text";
########## SIGNUP STUFF #########
sub cate_increment {
	
my $inc_cata = $_[0];
my $up_down = $_[1];

	open (ACC, "+<$main::path/categories.txt");
	if ($use_flock) {
		flock ACC, 2; 
	}
	@cata_data = <ACC>;

   foreach $cata_line(@cata_data) {
   	   chomp($cata_line);
	   @cata = split(/\|/,$cata_line);
	   ($key,$cata[0]) = split(/\%\%/,$cata[0]);
	   if ($inc_cata eq $key) {
	   	  if ($up_down) {
	   	  	$cata[8]++;
		  }
		  else {
		  	$cata[8] = $cata[8] - 1;
		  }
		  $caat=$cata[0];
		  $cata[0] = "$key\%\%$cata[0]";
		  $cata_line = join("\|",@cata);
		  $cata_line .= "\n";
	  	  last;
	   }  	
	   $cata_line .= "\n";
	}	
	  
	$dir_acc = "$caat/$dir_acc";

	seek (ACC, 0, 0);
	truncate (ACC,0);
	print ACC @cata_data;
	close (ACC);
}

########## GET CATEGORY HASH ##########
sub get_cata_hash {

open (ACC, "$main::path/categories.txt");
@cata_data = <ACC>;
close (ACC);

foreach $cata_line(@cata_data) {
	chomp($cata_line);
	@catas = split(/\%\%/,$cata_line);
	$cata{$catas[0]} = $catas[1];
}

return(%cata);
}

########## PRINT CATEGORY ##########
sub print_cata_hash {

#my %cata = shift;

open (ACC, ">$main::path/categories.txt");
while ( ($key, $value) = each(%cata) ) {
	print ACC "$key\%\%$value\n";
}
close (ACC);

}


########## CREATE NEW CATA ##########
sub new_cata_creation {

my $new_cata = $_[0];
my $new_data = $_[1];
my @char_set = ('a'..'z','0'..'9');

open (ACC, ">>$main::path/categories.txt")|| &main::error("printing to categories.txt");
print ACC "$new_cata\%\%$new_data\n";
close (ACC);

mkdir("$main::path/members/$new_cata", 0777);
chmod(0777,"$main::path/members/$new_cata");
foreach $ch(@char_set) {
	mkdir("$main::path/members/$new_cata/$ch", 0777);
	chmod(0777,"$main::path/members/$new_cata/$ch");
}

}

########## CREATE NEW CATA ##########
sub delete_cata {

my $new_cata = $_[0];

open (ACC, ">$main::path/categories.txt");
while ( ($key, $value) = each(%cata) ) {
	if ($key eq $new_cata) { next; }
	print ACC "$key\%\%$value\n";
}
close (ACC);

}

########## GET ACCOUNT DATA ##########
sub get_account { 

my @accarray = split(//,$account);
my $accfile = "$main::path/members/$cata/$accarray[0]/$account.dat";

unless (-e "$accfile") { 
	return(0); 
}

undef $/;
open (ACC, "$accfile") || &main::error("Error reading $accfile");
$acc_data = <ACC>;
close (ACC);
$/ = "\n";

($email,$name,$pwd,$size,$creation,$last_log,$size_added,$hf_on,
	$website_name,$website_des,$numdirs,$www_of,$www_name,$www_bgcolor,
	$www_bgimage,$www_text,$www_link,$www_vlink,$onhold,$address,$city,
	$state,$zip,$country,$telephone,$gender,$age,$icq,$education,
	$income,$occupation,$d_o_b,$moderator,$gbook_of,$op_in,$icon_url,
	$file_types,$ftp_per,$session_str,$num_dirs,$num_files,
	$custom_1,$custom_2,$custom_3,$custom_4,$custom_5,$custom_6,$custom_7,
	$custom_8,$custom_9,$custom_10,$marital,$signup_ip,$last_ip,$formmail_of) = split(/\n/,$acc_data);

($month,$day,$year1,$year2) = split (/\,/,$d_o_b);

@tfile = split(/\,/,$file_types);

foreach (@tfile) {
	if ($_ eq "\.shtml") {
		$main::good_types{$_} = "html";
	}
	else {		
		$main::good_types{$_} = "file";
	}
}

return(1);
}

########## PRINT ACCOUNT DATA BACK ######################
sub print_account {

my @accarray = split(//,$account);
my $accfile = "$main::path/members/$cata/$accarray[0]/$account.dat";
open (ACC, ">$accfile") || &main::error("Error printing $accfile");

print ACC "$email\n";
print ACC "$name\n";
print ACC "$pwd\n";
print ACC "$size\n";
print ACC "$creation\n";
print ACC "$last_log\n";
print ACC "$size_added\n";
print ACC "$hf_on\n";
print ACC "$website_name\n";
print ACC "$website_des\n";
print ACC "$numdirs\n";
print ACC "$www_of\n";
print ACC "$www_name\n";
print ACC "$www_bgcolor\n";
print ACC "$www_bgimage\n";
print ACC "$www_text\n";
print ACC "$www_link\n";
print ACC "$www_vlink\n";
print ACC "$onhold\n";
print ACC "$address\n";
print ACC "$city\n";
print ACC "$state\n";
print ACC "$zip\n";
print ACC "$country\n";
print ACC "$telephone\n";
print ACC "$gender\n";
print ACC "$age\n";
print ACC "$icq\n";
print ACC "$education\n";
print ACC "$income\n";
print ACC "$occupation\n";
print ACC "$d_o_b\n";
print ACC "$moderator\n";
print ACC "$gbook_of\n";
print ACC "$op_in\n";
print ACC "$icon_url\n";
print ACC "$file_types\n";
print ACC "$ftp_per\n";
print ACC "$session_str\n";
print ACC "$num_dirs\n";
print ACC "$num_files\n";
print ACC "$custom_1\n";
print ACC "$custom_2\n";
print ACC "$custom_3\n";
print ACC "$custom_4\n";
print ACC "$custom_5\n";
print ACC "$custom_6\n";
print ACC "$custom_7\n";
print ACC "$custom_8\n";
print ACC "$custom_9\n";
print ACC "$custom_10\n";
print ACC "$marital\n";
print ACC "$signup_ip\n";
print ACC "$last_ip\n";
print ACC "$formmail_of\n";

close (ACC);

}

######### DELETE ACCOUNT ##########
sub delete_account {

my @accarray = split(//,$account);
my $accfile = "$main::path/members/$cata/$accarray[0]/$account.dat";

unlink("$accfile") || &error("could not delete $accfile");

}

########## GET HASH OF ACCOUNTS IN CATEGORY ##########
sub get_acc_hash {

my $cata = $_[0];

@char_set = ('a'..'z','0'..'9');
$dir = "$main::path/members";

undef $/;
undef %acc_hash;

foreach $ch(@char_set) {

	opendir (DIR, "$dir/$cata/$ch") || &error("can not open $dir/$cata/$ch");
	@acc_arr = grep {!(/^\./) && -f "$dir/$cata/$ch/$_"}  readdir(DIR);
	close (DIR); 

	foreach $account(@acc_arr) {
		$account =~ s/\.dat//;
		my $accfile = "$main::path/members/$cata/$ch/$account.dat";
		open (ACC, "$accfile") || &main::error("Error reading $accfile");
		$acc_data = <ACC>;
		close (ACC);
	
		$acc_data =~ s/\n/\|/g;
		
		$acc_hash{$account} = $acc_data;
		
	}

}
$/ = "\n";
return(%acc_hash);
}
######### SORT HASHES ##########
sub sort_hash {
	my $x = shift;
	my %array=%$x;
	sort { $array{$a} cmp $array{$b} } keys %array;
}
1;


